export declare type OnDefaultValueFallback = (config: DynamicConfig, parameter: string, defaultValueType: string, valueType: string) => void;
/**
 * Returns the data for a DynamicConfig in the statsig console via typed get functions
 */
export default class DynamicConfig {
    name: string;
    value: Record<string, unknown>;
    private _ruleID;
    private _groupName;
    private _secondaryExposures;
    private _onDefaultValueFallback;
    constructor(configName: string, value?: Record<string, unknown>, ruleID?: string, groupName?: string | null, secondaryExposures?: Record<string, unknown>[], onDefaultValueFallback?: OnDefaultValueFallback | null);
    get<T>(key: string, defaultValue: T, typeGuard?: ((value: unknown) => value is T | null) | null): T;
    getValue(key: string, defaultValue?: boolean | number | string | object | Array<any> | null): unknown | null;
    getRuleID(): string;
    getGroupName(): string | null;
    _getSecondaryExposures(): Record<string, unknown>[];
}
