import { StatsigOptions } from './StatsigOptions';
export declare const ExceptionEndpoint = "https://statsigapi.net/v1/sdk_exception";
declare type ExtraArgs = Partial<{
    configName: string;
    tag: string;
    clientKey: string;
    hash: string;
    eventCount: number;
    nonLoggignArgs: Record<string, any>;
}>;
export default class ErrorBoundary {
    private sdkKey;
    private optionsLoggingCopy;
    private statsigMetadata;
    private seen;
    constructor(sdkKey: string, optionsLoggingCopy: StatsigOptions, sessionID: string);
    swallow<T>(task: () => T, extra?: ExtraArgs): void;
    capture<T>(task: () => T, recover: (e: unknown) => T, extra?: ExtraArgs): T;
    setup(sdkKey: string): void;
    private onCaught;
    logError(error: unknown, key?: string, extra?: ExtraArgs): void;
    private getDescription;
    private beginMarker;
    private endMarker;
}
export {};
