declare type ExposeLayer = (layer: Layer, key: string) => void;
/**
 * Returns the data for a Layer in the statsig console via typed get functions
 */
export default class Layer {
    name: string;
    private _value;
    private _ruleID;
    private _groupName;
    private _allocatedExperimentName;
    private _logExposure;
    constructor(layerName: string, value?: Record<string, unknown>, ruleID?: string, groupName?: string | null, allocatedExperimentName?: string | null, logExposure?: ExposeLayer | null);
    get<T>(key: string, defaultValue: T, typeGuard?: ((value: unknown) => value is T) | null): T;
    getValue(key: string, defaultValue?: boolean | number | string | object | Array<any> | null): unknown | null;
    getRuleID(): string;
    getGroupName(): string | null;
    getAllocatedExperimentName(): string | null;
}
export {};
