import { Marker } from './Diagnostics';
import { StatsigUser } from './StatsigUser';
export declare type LogEventData = {
    time: number;
    eventName: string;
    user: StatsigUser | null;
    value: string | number | null;
    metadata: Record<string, unknown> | null;
    secondaryExposures: Record<string, unknown>[];
};
export default class LogEvent {
    private time;
    private eventName;
    private user;
    private value;
    private metadata;
    private secondaryExposures;
    constructor(eventName: string);
    setUser(user: StatsigUser): void;
    setValue(value: string | number | null): void;
    setMetadata(metadata: Record<string, unknown> | null): void;
    setDiagnosticsMetadata(metadata: {
        context: string;
        markers: Marker[];
        statsigOptions: object | undefined;
    }): void;
    setTime(time: number): void;
    setSecondaryExposures(exposures: Record<string, unknown>[]): void;
    validate(): boolean;
    toObject(): LogEventData;
}
