import ConfigEvaluation from './ConfigEvaluation';
import { Marker } from './Diagnostics';
import ErrorBoundary from './ErrorBoundary';
import LogEvent from './LogEvent';
import { ExplicitStatsigOptions, StatsigOptions } from './StatsigOptions';
import { StatsigUser } from './StatsigUser';
import StatsigFetcher from './utils/StatsigFetcher';
export default class LogEventProcessor {
    private explicitOptions;
    private optionsLoggiingCopy;
    private fetcher;
    private queue;
    private flushTimer;
    private loggedErrors;
    private deduper;
    private deduperTimer;
    private sessionID;
    private errorBoundary;
    constructor(fetcher: StatsigFetcher, errorBoundry: ErrorBoundary, explicitOptions: ExplicitStatsigOptions, optionsLoggiingCopy: StatsigOptions, sessionID: string);
    log(event: LogEvent, errorKey?: string | null): void;
    flush(fireAndForget?: boolean, abortSignal?: AbortSignal): Promise<void>;
    shutdown(timeout?: number): Promise<void>;
    logStatsigInternal(user: StatsigUser | null, eventName: string, metadata: Record<string, unknown> | null, secondaryExposures?: Record<string, unknown>[] | null, value?: string | number | null): void;
    logGateExposure(user: StatsigUser, gateName: string, evaluation: ConfigEvaluation, isManualExposure: boolean): void;
    logConfigExposure(user: StatsigUser, configName: string, evaluation: ConfigEvaluation, isManualExposure: boolean): void;
    logLayerExposure(user: StatsigUser, layerName: string, parameterName: string, evaluation: ConfigEvaluation, isManualExposure: boolean): void;
    logConfigDefaultValueFallback(user: StatsigUser, message: string, metadata: Record<string, unknown>): void;
    private maybeAddManualExposureFlagToMetadata;
    private safeAddEvaulationDetailsToEvent;
    private isUniqueExposure;
    logDiagnosticsEvent(diagnostics: {
        context: string;
        markers: Marker[];
    }, user?: StatsigUser | null): void;
    private addDiagnosticsMarkers;
}
